#include "stdafx.h"
#include "clf_random.h"

static int a = 0;
const int b = 32456821; // notice the ..x21 pattern
const int rand_max = 65535; // the maximum +1
const int m = rand_max+1; // the maximum +1

void init_random(short seed)
{
	a = seed;
}

// multiply eliminating overflow
static int safe_multiply(int p, int q)
{
	const int m1 = 10000;
	int p1,p0,q1,q0;
	int ret;
	p1 = p/m1; p0 = p%m1;
	q1 = q/m1; q0 = q%m1;

	ret = ((p0*q1+p1*q0)%m1)*m1+p0*q0;

	return ret;
}

int random()
{
	a = (safe_multiply(a,b)+1) % m;
	return a;
}

int random(int lim)
{
	double r = ((double)random()) / ((double)rand_max);
	r = r * (double)lim;
	return (int)floor(r+0.5);
}
